#include "socketudp.h"
#include "socketexceptions.h"

std::string server_ip="192.168.100.97";
int server_port=49152;

int main(int argc,char *argv[])
{
  CEventServer *event_server=CEventServer::instance();
  int num=0;
  TSocket_info info;
  CSocketUDP client("client");
  unsigned char msg[5];
  std::list<std::string> events;

  try{
    info.address=server_ip;
    info.port=server_port;
    client.open(&server_port);
    client.config();
    events.push_back(client.add_client(server_ip));
    std::cout << "connected." << std::endl;
    while(1)
    {
      event_server->wait_all(events);
      num=client.get_num_data_from(server_ip);
      num=client.read_from(server_ip,msg,num);
      std::cout << msg << "," << num << std::endl;
    }
    std::cout << "closing connection ..." << std::endl;
    client.close();
    sleep(1);
  }catch(CException &e){
    std::cout << e.what() << std::endl;
  }
}
